
variable "common_tags" {
  type        = map(string)
  description = "(Optional) Map of common tags for all taggable resources"
  default     = {}
}

variable "health_check_path" {
  type        = string
  description = "The endpoint to check for Vault's health status"
  default     = "/v1/sys/health?activecode=200\u0026standbycode=200\u0026sealedcode=200\u0026uninitcode=200"
}

variable "instance_count" {
  type        = number
  description = "Number of Vault VMs to deploy in Scale Set"
  default     = 5
}

variable "instance_type" {
  type        = string
  description = "Scale Set VM SKU"
  default     = "Standard_D2s_v3"
}

variable "key_vault_id" {
  type        = string
  description = "Azure Key Vault containing TLS certificates (will also be used to store Vault seal secret)"
  default     = ""
}

variable "key_vault_ssl_cert_secret_id" {
  type        = string
  description = "Secret ID of Key Vault Certificate for load balancer SSL"
  default     = ""
}

variable "key_vault_vm_tls_secret_id" {
  type        = string
  description = "ID of Key Vault Secret where VM TLS cert bundle is stored"
  default     = ""
}

variable "lb_autoscale_max_capacity" {
  type        = number
  description = "(Optional) Autoscaling capacity unit cap for Application Gateway (ignored if lb_sku_capacity is provided)"
  default     = null
}

variable "lb_autoscale_min_capacity" {
  type        = number
  description = "Autoscaling minimum capacity units for Application Gateway (ignored if lb_sku_capacity is provided)"
  default     = 0
}

variable "lb_backend_ca_cert" {
  type        = string
  description = "PEM cert of Certificate Authority used to sign key in key_vault_vm_tls_secret_id"
  default     = ""
}

variable "lb_private_ip_address" {
  type        = string
  description = "(Optional) Load balancer fixed IPv4 address"
  default     = null
}

variable "lb_sku_capacity" {
  type        = number
  description = "(Optional) Fixed (non-autoscaling) number of capacity units for Application Gateway (overrides lb_autoscale_min_capacity/lb_autoscale_max_capacity variables)"
  default     = null
}

variable "lb_subnet_id" {
  type        = string
  description = "Subnet where Vault Application Gateway will be deployed"
  default     = ""
}

variable "leader_tls_servername" {
  type        = string
  description = "One of the DNS Subject Alternative Names on the cert in key_vault_vm_tls_secret_id"
  default     = ""
}

variable "resource_group" {
  type        = object({
    name     = string
    location = string
  })
  description = "Azure resource group in which resources will be deployed"
  default     = ""
}

variable "resource_name_prefix" {
  type        = string
  description = "Prefix applied to resource names (e.g. providing \"dev\" will create a VM Scale Set named \"dev-vault\")"
  default     = ""
}

variable "ssh_public_key" {
  type        = string
  description = "Public key to use for SSH access to Vault instances"
  default     = ""
}

variable "ssh_username" {
  type        = string
  description = "SSH admin username for Vault instances"
  default     = "azureuser"
}

variable "ultra_ssd_enabled" {
  type        = bool
  description = "Enable VM scale set Ultra SSD data disks compatibility"
  default     = true
}

variable "user_supplied_key_vault_key_name" {
  type        = string
  description = "(Optional) User-provided Key Vault Key name. Providing this will disable the KMS submodule from generating a KMS key used for Vault auto-unseal."
  default     = null
}

variable "user_supplied_lb_identity_id" {
  type        = string
  description = "(Optional) User-provided User Assigned Identity for the Application Gateway. The minimum permissions must match the defaults generated by the IAM submodule for TLS bundle retrieval."
  default     = null
}

variable "user_supplied_source_image_id" {
  type        = string
  description = "(Optional) Image ID for Vault instances. If provided, please ensure it will work with the default userdata config (assumes latest version of Ubuntu LTS). Otherwise, please provide your own custom userdata using the user_supplied_userdata_path variable."
  default     = null
}

variable "user_supplied_userdata_path" {
  type        = string
  description = "(Optional) File path to custom VM configuration (i.e. cloud-init config) being supplied by the user"
  default     = null
}

variable "user_supplied_vm_identity_id" {
  type        = string
  description = "(Optional) User-provided User Assigned Identity for Vault servers. The minimum permissions must match the defaults generated by the IAM submodule for cloud auto-join and auto-unseal."
  default     = null
}

variable "vault_application_security_group_ids" {
  type        = list(string)
  description = "Application Security Group ID for Vault VMs"
  default     = ""
}

variable "vault_subnet_id" {
  type        = string
  description = "Subnet where Vault will be deployed"
  default     = ""
}

variable "vault_version" {
  type        = string
  description = "Vault version"
  default     = "1.8.2"
}

variable "zones" {
  type        = list(string)
  description = "Azure availability zones for deployment"
  default     = [
  "1",
  "2",
  "3"
]
}

